import { CompletionItem, CompletionParams, IConnection, CompletionList } from "vscode-languageserver";
import { IElmWorkspace } from "../elmWorkspace";
export declare type CompletionResult = CompletionItem[] | CompletionList | null | undefined;
export declare class CompletionProvider {
    private connection;
    private qidRegex;
    private qidAtStartOfLineRegex;
    constructor(connection: IConnection, elmWorkspaces: IElmWorkspace[]);
    protected handleCompletionRequest: (params: CompletionParams, elmWorkspace: IElmWorkspace) => CompletionResult;
    private findPreviousWord;
    private getImportableModules;
    private getExposedFromModule;
    private getCompletionsFromOtherFile;
    private getSameFileTopLevelCompletions;
    private getRecordCompletions;
    private createFunctionCompletion;
    private createFieldOrParameterCompletion;
    private createTypeCompletion;
    private createTypeAliasCompletion;
    private createOperatorCompletion;
    private createUnionConstructorCompletion;
    private createModuleCompletion;
    private createCompletion;
    private createPreselectedCompletion;
    private findDefinitionsForScope;
    private getPossibleImports;
    private createSnippet;
    private createSnippets;
    private createKeywordCompletion;
    private getKeywords;
}
